#include <iostream>
#include <string>
#include <sstream>
using namespace std;

// syntax to run command : cat gutenberg.txt | g2g [columns] > gp2x.txt

int main (int argc, char** argv) {

	//check the args
	int columns;
	if (argc == 1) {
		columns = 50; // about right default for gp2x
	} else {
		// at least 2 args
		stringstream as (argv[1]);
		as >> columns;
	}

	int len = 0;
	string line;
	while (getline(cin, line)) {
		int ll = line.length ();
		int lensum = len + ll;
		if (lensum < columns) {
			string newl;
			if (ll < 2) newl= "\n\n"; else newl = "\n";
			cout << line << newl;
			len = 0;
		} else {
			stringstream ss (line);
			string s;
			while (ss >> s) {
				int ls = s.length() + 1;
				if ((len + ls) > columns) {
					cout << '\n';
					len = 0;
				}
				cout << s << ' ';
				len += ls;
			}
		}
	}
}
